#!/bin/bash

# Create a build directory if it doesn't exist
mkdir -p build

# Build for Linux
GOOS=linux GOARCH=amd64 go build -o build/memory-mcp-linux-amd64
echo "Built for Linux (amd64)"

# Build for Windows
GOOS=windows GOARCH=amd64 go build -o build/memory-mcp-windows-amd64.exe
echo "Built for Windows (amd64)"

# Build for macOS (Intel)
GOOS=darwin GOARCH=amd64 go build -o build/memory-mcp-darwin-amd64
echo "Built for macOS (Intel/amd64)"

# Build for macOS (Apple Silicon)
GOOS=darwin GOARCH=arm64 go build -o build/memory-mcp-darwin-arm64
echo "Built for macOS (Apple Silicon/arm64)"

echo "All builds completed successfully!"